program wizpong;
global
	finished = 0;
	score = 0;
	topscore = 0;
begin
	SET_MODE(320,240,16);
	LOAD_FPG("pong.fpg");
	ball(160,120);
	paddle(2,5,120);
	paddle(3,315,120);
	WRITE_INT(0,160,5,1,&score);
	repeat
		if (finished == 1 and key(_enter))
		  DELETE_text(0);
		  WRITE_INT(0,160,5,1,&score);
		  ball(160,120);
		  finished = 0;
		  score = 0;
		end;	
		frame;
	until (key(_space)) 
end;

process ball(x,y)
local
	int dx = 5;
	int dy = 5;
	int dys=1;
begin
	graph = 1;
	loop
		x+=dx;
		y+=dy;
		if(COLLISION(TYPE paddle))
			score += 1;
			dx = -dx;
			dys = dy/abs(dy);
			dy = rand(1,5)*dys;
		end
		if(y<3 or y>237)dy = -dy;end
		if(x<0 or x>320)
			gameover();
			return;
		end;
		frame;
	end;
end;

process paddle(z,x,y)
begin
	graph=z;
	loop 
		if(key(_up) and y>10 and z==2)y-=5;end
		if(key(_down) and y<230 and z==2)y+=5;end

		if(key(_z) and y>10 and z==3)y-=5;end
		if(key(_x) and y<230 and z==3)y+=5;end

		frame;
	end;
end;

process gameover()
begin
	write(0,160,110,4,"GameOver");
	write(0,160,120,4,"press START to try again");
	write(0,160,130,4,"press SELECT to exit");
	write(0,160,140,1,"top score:  ");
	if (score>topscore)
		topscore=score;
	end;
	write_int(0,195,140,0,&topscore);
	finished = 1;
	return;
end;